

//************************************************************************************************************************************
//  TEXT - Text on 1 line
//************************************************************************************************************************************

#macro Text(value, tstart, tw, th)
	#local tstring = text {ttf besch_font, value, 1.0, 0}
	#local tscale = tw / (max_extent(tstring).x);
	#if (tscale > 0.8) #local tscale = 0.8; #end
	object{tstring scale<tscale,tscale*1.5,1> rotate<90,0,0> translate<tstart, th +0.01, -tscale/2> pigment{Gray70}} 
#end



//************************************************************************************************************************************
//  TEXT 2 - Text on 2 lines with split at the first space
//************************************************************************************************************************************

#macro Text2(value, tstart, tw, th)
	//
	#local string2 = "";
	#local index = 1;
	#while (index <= strlen(value))
		// -------------------------------------------------------------- if space
		#if (!(asc(substr(value, index, 1)) - 32))
			// ---------------------------------------------------------- if there is a "next charachter"
			#if (index +1 <= strlen(value))
				// ------------------------------------------------------ if the "next charachter" is not a space
				#if ((asc(substr(value, index + 1, 1)) - 32))
					// -------------------------------------------------- split the string and exit
					#local string1 = substr(value, 1, index);
					#local string2 = substr(value, index + 1, strlen(value) - index);
					#local index = 999;
				#end
			#end
		#end
		#local index = index + 1;
	#end
	//
	#if (strlen(string2))
		// -------------------------------------------------------------- two lines
		#local tstr1 = text {ttf besch_font, string1, 1.0, 0}
		#local tstr2 = text {ttf besch_font, string2, 1.0, 0}
		#local tscale1 = tw / (max_extent(tstr1).x);
		#local tscale2 = tw / (max_extent(tstr2).x);
		#local tscale = min(tscale1 ,tscale2);
		#if (tscale > 0.8) #local tscale = 0.8; #end
		object{tstr1 scale<tscale,tscale*1.5,1> rotate<90,0,0> translate<tstart, th +0.01, +tscale*0.2> pigment{Gray70}}
		object{tstr2 scale<tscale,tscale*1.5,1> rotate<90,0,0> translate<tstart, th +0.01, -tscale*1.05> pigment{Gray70}} 
	#else
		// -------------------------------------------------------------- single line
		#local tstr = text {ttf besch_font, value, 1.0, 0}
		#local tscale = tw / (max_extent(tstr).x);
		#if (tscale > 0.8) #local tscale = 0.8; #end
		object{tstr scale<tscale,tscale*1.5,1> rotate<90,0,0> translate<tstart, th +0.01, -tscale/2> pigment{Gray70}} 
	#end
#end










/********************************************************************************************************************************************
//TO220 Gehaeuse liegend (kurz Beine bis zur Biegung)
//Tobias Mueller <Tobias_Mueller(replace with at)twam.info>
********************************************************************************************************************************************/
#macro TR_TO220_L2_GRND(value)
	union{
	union{
	union{
	difference{
	box{<-0.375,0,0><0.375,8.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}}
	difference{
	cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
	cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}}
	box{<-0.375,8.5,0.6><0.375,9.1,4.0>}
	translate <0,0,2.54>}
	union{
	difference{
	box{<-0.375,0,0><0.375,8.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}}
	difference{
	cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
	cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}}
	box{<-0.375,8.5,0.6><0.375,9.1,4.0>}
	translate<-2.54,0,2.54>}
	union{
	difference{
	box{<-0.375,0,0><0.375,8.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}}
	difference{
	cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
	cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}}
	box{<-0.375,8.5,0.6><0.375,9.1,4.0>}
	translate<2.54,0,2.54>}
	translate<0,-6.58,-4>}
	union{
	difference{
	box{<-5.1,22.6,4.5><5.1,29,4.5-1.27>}
	cylinder{<0,0,0><0,0,2>1.9 translate<0,26.2,2.6>}
	box{<0,0,0><1,3,3> rotate<0,0,20> translate<5.1,26.5,2>}
	box{<0,0,0><-1,3,3> rotate<0,0,-20> translate<-5.1,26.5,2>}}
	box{<-4,22.6,4.5><4,16,4.501>}
	difference{
	box{<-5.1,13.5,0><5.1,22.6,4.5>}
	box{<-5.5,0,0><5.5,3,-2> rotate<45,0,0> translate<0,22.6-1.8,0> }
	box{<-5.5,0,0><5.5,-1,2> rotate<-20,0,0> translate<0,13.5,3.7> }
	cylinder{<0,14.5,0.1><0,14.5,-0.05>0.7}
	pigment{Gray30}}
	text{ttf besch_font value 0.5,0 pigment{White} scale<1.7,2,1.7>
	translate<-3.5,18,-0.01>}
	box{<0,2,0><1.5,3.7,0.6> translate<-0.75,9.8,1.5>}
	box{<0,2,0><1.5,3.7,0.6> translate<-0.75,0,1.5>
	translate<2.54,9.8,0>}
	box{<0,2,0><1.5,3.7,0.6> translate<-0.75,0,1.5>
	translate<-2.54,9.8,0>}
	translate<-0,-13.5,0>rotate<90,0,0>translate<-0,4,1.3>}
	translate<0,0.6,-2.7>
	texture{col_silver}}
#end

#macro TR_TO220_L2(value)
	object{TR_TO220_L2_GRND(value)}
#end

/********************************************************************************************************************************************
//TO220 Gehaeuse liegend
********************************************************************************************************************************************/
#macro TR_TO220_L_GRND(value)
	union{union{union{
	difference{
	box{<-0.375,0,0><0.375,8.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}}
	difference{
	cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
	cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}}
	box{<-0.375,8.5,0.6><0.375,9.1,4.0>}}
	union{
	difference{
	box{<-0.375,0,0><0.375,8.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}}
	difference{
	cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
	cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}}
	box{<-0.375,8.5,0.6><0.375,9.1,4.0>}translate<-2.54,0,0>}
	union{
	difference{
	box{<-0.375,0,0><0.375,8.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}}
	difference{
	cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
	cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}}
	box{<-0.375,8.5,0.6><0.375,9.1,4.0>}translate<2.54,0,0>}
	translate<0,-6.58,-4>}
	union{
	difference{
	box{<-5.1,22.6,4.5><5.1,29,4.5-1.27>}
	cylinder{<0,0,0><0,0,2>1.9 translate<0,26.2,2.6>}
	box{<0,0,0><1,3,3> rotate<0,0,20> translate<5.1,26.5,2>}
	box{<0,0,0><-1,3,3> rotate<0,0,-20> translate<-5.1,26.5,2>}}
	box{<-4,22.6,4.5><4,16,4.501>}
	difference{
	box{<-5.1,13.5,0><5.1,22.6,4.5>}
	box{<-5.5,0,0><5.5,3,-2> rotate<45,0,0> translate<0,22.6-1.8,0> }
	box{<-5.5,0,0><5.5,-1,2> rotate<-20,0,0> translate<0,13.5,3.7> }
	cone{<-5.4,16.5,-0.01>1.4<-5.4,16.5,3.23>1.2}
	cone{<5.4,16.5,-0.01>1.4<5.4,16.5,3.23>1.2}
	cylinder{<0,14.5,0.1><0,14.5,-0.05>0.7}
	pigment{Gray30}}
	text{ttf besch_font value 0.5,0 pigment{White} scale<1.7,2,1.7> translate<-3.5,18,-0.01>}
	box{<0,0,0><1.5,3.7,0.6> translate<-0.75,9.8,1.5>}
	box{<0,0,0><1.5,3.7,0.6> translate<-0.75,0,1.5> translate<2.54,9.8,0>}
	box{<0,0,0><1.5,3.7,0.6> translate<-0.75,0,1.5> translate<-2.54,9.8,0>}
	translate<-0,-13.5,0>rotate<90,0,0>translate<-0,4,1.3>}
	translate<0,0.6,-2.7>
	texture{col_silver}}
#end

#macro TR_TO220_L(value)
	object{TR_TO220_L_GRND(value)}
#end

/********************************************************************************************************************************************
//TO220 Gehaeuse stehend
********************************************************************************************************************************************/
#macro TR_TO220_S_GRND(value)
	union{union{union{
	#if(pin_short=off)
	#local tr_to220_s_pin = 9.5;
	#else
	#local tr_to220_s_pin = 9.5-(pcb_height+pin_length);
	#end
	difference{
	box{<0,tr_to220_s_pin,0><0.75,13.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45,tr_to220_s_pin,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3,tr_to220_s_pin,-0.2>}}
	difference{
	box{<0,tr_to220_s_pin,0><0.75,13.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45,tr_to220_s_pin,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3,tr_to220_s_pin,-0.2>}
	translate<-2.54,0,0>}
	difference{
	box{<0,tr_to220_s_pin,0><0.75,13.5,0.6>}
	box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45,tr_to220_s_pin,-0.2>}
	box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3,tr_to220_s_pin,-0.2>}
	translate<2.54,0,0>}
	box{<0,0,0><1.5,3.7,0.6> translate<-0.375,9.8,0>}
	box{<0,0,0><1.5,3.7,0.6> translate<-0.375,0,0> translate<2.54,9.8,0>}
	box{<0,0,0><1.5,3.7,0.6> translate<-0.375,0,0> translate<-2.54,9.8,0>}
	translate<-0.75/2,0,1.6>}
	difference{
	box{<-5.1,22.6,4.5><5.1,29,4.5-1.27>}
	cylinder{<0,0,0><0,0,2>1.9 translate<0,26.2,2.6>}
	box{<0,0,0><1,3,3> rotate<0,0,20> translate<5.1,26.5,2>}
	box{<0,0,0><-1,3,3> rotate<0,0,-20> translate<-5.1,26.5,2>}}
	box{<-4,22.6,4.5><4,16,4.501>}
	texture{col_silver}}
	difference{
	box{<-5.1,13.5,0><5.1,22.6,4.5>}
	box{<-5.5,0,0><5.5,3,-2> rotate<45,0,0> translate<0,22.6-1.8,0> }
	box{<-5.5,0,0><5.5,-1,2> rotate<-20,0,0> translate<0,13.5,3.7> }
	cone{<-5.4,16.5,-0.01>1.4<-5.4,16.5,3.23>1.2}
	cone{<5.4,16.5,-0.01>1.4<5.4,16.5,3.23>1.2}
	cylinder{<0,14.5,0.1><0,14.5,-0.05>0.7}
	pigment{Gray30}}
	text{ttf besch_font value 0.5,0 pigment{White} scale<1.7,2,1.7> translate<-3.5,18,-0.01>}
	translate<0,-9.5,-4.5>}
#end

#macro TR_TO220_S(value)
	object{TR_TO220_S_GRND(value)}
#end




/********************************************************************************************************************************************
//TO220 ISO  
********************************************************************************************************************************************/
#macro TR_TO220_ISO_GRND(value)
union{
	union{
		union{
				difference{
							box{<-0.375,0,0><0.375,8.5,0.6>}
							box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
							box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}
				}
				difference{
							cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
							cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}
				}
				box{<-0.375,8.5,0.6><0.375,9.1,4.0>}
		}
		union{
				difference{
						box{<-0.375,0,0><0.375,8.5,0.6>}
						box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
						box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}
				}
				difference{
							cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
							cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}
				}
				box{<-0.375,8.5,0.6><0.375,9.1,2.5>}
				rotate<0,38,0>
				translate<-3.81,0,0>

		}
		union{
				difference{
							box{<-0.375,0,0><0.375,8.5,0.6>}
							box{<0,0,0><1,1,1> rotate<0,0,-25> translate<0.45-0.375,0,-0.2>}
							box{<0,0,0><-1,1,1> rotate<0,0,25> translate<0.3-0.375,0,-0.2>}
				}
				difference{
							cylinder{<-0.375,8.5,0.6><0.375,8.5,0.6>0.6}
							cylinder{<-0.38,8.0,1.1><0.38,8.0,1.1>0.5}
				}
				box{<-0.375,8.5,0.6><0.375,9.1,2.5>}
				rotate<0,-38,0>
				translate<3.81,0,0>
		}
		translate<0,-6.58,-4>
	}
	union{
			difference{
						box{<-5.1,22.6,4.5><5.1,29,4.5-1.27>}
						cylinder{<0,0,0><0,0,2>1.9 translate<0,26.2,2.6>}
						box{<0,0,0><1,3,3> rotate<0,0,20> translate<5.1,26.5,2>}
						box{<0,0,0><-1,3,3> rotate<0,0,-20> translate<-5.1,26.5,2>}
			}
			box{<-4,22.6,4.5><4,16,4.501>}
			difference{
						box{<-5.1,13.5,0><5.1,22.6,4.5>}
						box{<-5.5,0,0><5.5,3,-2> rotate<45,0,0> translate<0,22.6-1.8,0>}
						box{<-5.5,0,0><5.5,-1,2> rotate<-20,0,0> translate<0,13.5,3.7>}
						cone{<-5.4,16.5,-0.01>1.4<-5.4,16.5,3.23>1.2}
						cone{<5.4,16.5,-0.01>1.4<5.4,16.5,3.23>1.2}
						cylinder{<0,14.5,0.1><0,14.5,-0.05>0.7}
						pigment{Gray30}
			}
			text{
				ttf besch_font value 0.5,0 pigment{White} scale<1.7,2,1.7> translate<-3.5,18,-0.01>
			}
			box{<0,0,0><1.5,3.7,0.6> translate<-0.75,9.8,1.5>}
			box{<0,0,0><1.5,3.7,0.6> translate<-0.75,0,1.5> translate<2.54,9.8,0>}
			box{<0,0,0><1.5,3.7,0.6> translate<-0.75,0,1.5> translate<-2.54,9.8,0>}
			translate<-0,-13.5,0>
			rotate<90,0,0>
			translate<-0,4,1.3>
		}
		translate<0,0.6,-2.7>
		texture{col_silver}
	}
#end

#macro TR_TO220_ISO(value)
	object{TR_TO220_ISO_GRND(value)}
#end






/********************************************************************************************************************************************
//TO92 Gehaeuse stehend mittlerer Pin gebogen
********************************************************************************************************************************************/
#macro TR_TO92_G_GRND(value)
	union
	{
		#if(pin_short=off)
			box{<0,0,0><0.48,14,0.44> texture{col_silver} translate<-1.27,0,0>}									//linker Pin
			box{<0,0,0><0.48,11.5,0.44> texture{col_silver} translate <0,0,1.905> }								//mittlerer Pin unten
			box{<0,0,0><0.48,14,0.44> texture{col_silver} translate<1.27,0,0>}									//rechter Pin
		#else
			box{<0,11-(pcb_height+pin_length),0><0.48,14,0.44> texture{col_silver} translate<-1.27,0,0>}                                               //linker Pin
			box{<0,11-(pcb_height+pin_length),0><0.48,11.5,0.44> texture{col_silver} translate <0,0,1.905> }                                            //mittlerer Pin unten
			box{<0,11-(pcb_height+pin_length),0><0.48,14,0.44> texture{col_silver} translate<1.27,0,0>}                                                //rechter Pin
		#end

		box{<0,13.15,0><0.48,14,0.44> texture{col_silver} }														//mittlerer Pin Gehaeuse
		box{<0,0,0><0.48,2.8,0.44> texture{col_silver} rotate -45*x translate <0,11.18,1.35+0.665> }			//mittlerer Pin Schraege
		box{<-0.1,12,0><0.58,13,0.44> texture{col_silver} translate<-1.27,0,0>}									//Abstandhalter links
		box{<-0.1,12,0><0.58,13,0.44> texture{col_silver} translate<1.27,0,0>}									//Abstandhalter rechts
		difference
		{																										//Transitorkoerper
			cylinder{<0,14,0><0,19.2,0>2.4 pigment{ Gray30}translate<0.12,0,0>}
			box{<-3,13.9,-1><3,20,-3> pigment{ Gray30}}
		}
		union
		{
			Text2(value, -1.6, 3.4, 1.0)																		// text
			rotate<-90,0,0>
			translate<0, 17, 0>
		}
		translate<-0.24,-11,-0.22>
	}
#end

#macro TR_TO92(value)
	object{TR_TO92_G_GRND(value)}
#end

/********************************************************************************************************************************************
//TO92 Gehaeuse stehend mittlerer Pin nicht gebogen
********************************************************************************************************************************************/
#macro TR_TO92L1_GRND(value)
	union
	{
		#if(pin_short=off)
			box{<0,0,0><0.48,10,0.44> translate<-2.54,0,0>}											//linker Pin
			box{<0,0,0><0.48,14,0.44> }																//mittlerer Pin
			box{<0,0,0><0.48,10,0.44> translate<2.54,0,0>}											//rechter Pin
		#else
			box{<0,9.5-(pcb_height+pin_length),0><0.48,10,0.44> translate<-2.54,0,0>}				//linker Pin
			box{<0,9.5-(pcb_height+pin_length),0><0.48,14,0.44> }									//mittlerer Pin
			box{<0,9.5-(pcb_height+pin_length),0><0.48,10,0.44> translate<2.54,0,0>}				//rechter Pin
		#end

		box{<-0.24,0,0><0.24,2,0.44> rotate<0,0,-40> translate<-2.30,9.85,0>}
		box{<-0.24,0,0><0.24,2,0.44> rotate<0,0,40> translate< 2.78,9.85,0>}
		box{<0,11.25,0><0.48,14,0.44> translate<-1.27,0,0>}											//linker Pin
		box{<0,11.25,0><0.48,14,0.44> translate<1.27,0,0>}											//rechter Pin
		box{<-0.1,12,0><0.58,13,0.44> translate<-1.27,0,0>}											//Abstandhalter links
		box{<-0.1,12,0><0.58,13,0.44> }																//Abstandhalter mitte
		box{<-0.1,12,0><0.58,13,0.44> translate<1.27,0,0>}											//Abstandhalter rechts
		difference
		{																							//Transitorkoerper
			cylinder{<0,14,0><0,19.2,0>2.4 pigment{ Gray30}translate<0.12,0,0>}
			box{<-3,13.9,-1><3,20,-3> pigment{ Gray30}}
		}
		union
		{
			Text2(value, -1.6, 3.4, 1.0)																// text
			rotate<-90,0,0>
			translate<0, 17, 0>
		}
		texture{col_silver}
		translate<-0.24,-9.5,0>
	}
#end

#macro TR_TO92L1(value)
	object{TR_TO92L1_GRND(value)}
#end






/********************************************************************************************************************************************
//Macros for SIOV EPCOS Standard Series
//Designed by Philippe Boucheny <philippe.boucheny(at)free.fr>
//Rev. 1.0  14/01/06
//e,a,b,s,h,l,d parameters, see epcos datasheet: Dimensions
//To add a missing SIOV, just duplicate, rename a macro and copy parameters from EPCOS datasheet. They are in the same order.
********************************************************************************************************************************************/
#macro RES_DIS_SIOV_GRND(value,e,a,b,s,h,l,d)
    #local Siov = texture
    {
        pigment{color red 0.17 green 0.24 blue 0.88}
        finish 
        {
            ambient 0.3
            diffuse 0.7
            specular 0.4
        }
    }
    union
    {
        union
        {
            superellipsoid {<1.0, 0.6> scale <b/2,b/2,s/2> }
            intersection
            {
                superellipsoid {<1.0, 0.6> scale <b/2,b/2,s/2+0.01> }
                union
                {
                    text {ttf global_fontfile_arial value 1, 0 scale 1 rotate<0,0,0> translate<-2,+1,-s/2>}
                    text {ttf global_fontfile_eagle3d ">" 1, 0 scale 2 rotate<0,0,0> translate<-3,-1.5,-s/2>}
                    text {ttf global_fontfile_eagle3d "AG" 1, 0 scale 1 rotate<0,0,0> translate<0.5,-1,-s/2>}
                    text {ttf global_fontfile_arial "9235" 1, 0 scale 1 rotate<0,0,0> translate<-1,-2.5,-s/2>}
					scale<b/9,b/9,1>
                }            
                pigment{White} 
            }
            sphere{<+e/2,+b/2-h+d/2,-a/2> (s/2-a/2)/2}
            sphere{<-e/2,+b/2-h+d/2,+a/2> (s/2-a/2)/2}
            //cone{<+e/2,-b/4,-a/2> (s/2-a/2) <+e/2,+b/2-h+d/2,-a/2> (s/2-a/2)/2}
            //cone{<-e/2,-b/4,+a/2> (s/2-a/2) <-e/2,+b/2-h+d/2,+a/2> (s/2-a/2)/2}
            #if(b=7)
                cone{<+e/3,-b/4,-a/3> (s/2-a/2) <+e/2,+b/2-h+d/2,-a/2> (s/2-a/2)/2}
                cone{<-e/3,-b/4,+a/3> (s/2-a/2) <-e/2,+b/2-h+d/2,+a/2> (s/2-a/2)/2}
            #else
                sphere{<+e/2,-b/4,-a/3> (s/2-a/2)}
                cone{<+e/2,-b/4,-a/3> (s/2-a/2) <+e/2,+b/2-h+d/2,-a/2> (s/2-a/2)/2}
                sphere{<-e/2,-b/4,+a/3> (s/2-a/2)}
                cone{<-e/2,-b/4,+a/3> (s/2-a/2) <-e/2,+b/2-h+d/2,+a/2> (s/2-a/2)/2}
            #end
            texture{Siov}
        }
    	#if(pin_short=off)
            cylinder{<+e/2,+b/2-h+d/2,-a/2><+e/2,+b/2-h-l,-a/2> d/2 texture{col_silver}}
            cylinder{<-e/2,+b/2-h+d/2,+a/2><-e/2,+b/2-h-l,+a/2> d/2 texture{col_silver}}
    	#else
            cylinder{<+e/2,+b/2-h+d/2,-a/2><+e/2,+b/2-h-1*(pcb_height+pin_length)-0.2,-a/2> d/2 texture{col_silver}}
            cylinder{<-e/2,+b/2-h+d/2,+a/2><-e/2,+b/2-h-1*(pcb_height+pin_length)-0.2,+a/2> d/2 texture{col_silver}}
    	#end
      
	translate<0,h-b/2,0>
	rotate<0,90,0>
    }
#end

#macro RES_DIS_SIOV_05_11(value)
	object{RES_DIS_SIOV_GRND(value,5,1.2,7,3.3,8.5,30,0.6)}
#end
#macro RES_DIS_SIOV_05_14(value)
	object{RES_DIS_SIOV_GRND(value,5,1.3,7,3.4,8.5,30,0.6)}
#end
#macro RES_DIS_SIOV_05_75(value)
	object{RES_DIS_SIOV_GRND(value,5,1.3,7,3.4,8.5,30,0.6)}
#end
#macro RES_DIS_SIOV_07_14(value)
	object{RES_DIS_SIOV_GRND(value,5,1.3,9,3.5,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_20(value)
	object{RES_DIS_SIOV_GRND(value,5,1.2,9,3.6,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_30(value)
	object{RES_DIS_SIOV_GRND(value,5,1.5,9,3.7,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_60(value)
	object{RES_DIS_SIOV_GRND(value,5,1.2,9,3.3,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_75(value)
	object{RES_DIS_SIOV_GRND(value,5,1.3,9,3.6,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_95(value)
	object{RES_DIS_SIOV_GRND(value,5,1.3,9,3.4,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_250(value)
	object{RES_DIS_SIOV_GRND(value,5,1.8,9,4.2,11,30,0.6)}
#end
#macro RES_DIS_SIOV_07_275(value)
	object{RES_DIS_SIOV_GRND(value,5,2,9,4.4,11,30,0.6)}
#end
#macro RES_DIS_SIOV_10_11(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.4,12,4,14.5,30,0.8)}
#end
#macro RES_DIS_SIOV_10_20(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.8,12,4.5,14.5,30,0.8)}
#end
#macro RES_DIS_SIOV_10_75(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.5,12,4.2,14.5,30,0.8)}
#end
#macro RES_DIS_SIOV_10_275(value)
	object{RES_DIS_SIOV_GRND(value,7.5,2.2,12,5,14.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_11(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.4,15.5,4,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_14(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.5,15.5,4.2,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_20(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.9,15.5,4.6,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_25(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.7,15.5,4.2,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_30(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.8,15.5,4.4,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_60(value)
	object{RES_DIS_SIOV_GRND(value,7.5,1.5,15.5,4,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_14_250(value)
	object{RES_DIS_SIOV_GRND(value,7.5,2,15.5,4.8,18.5,30,0.8)}
#end
#macro RES_DIS_SIOV_20_20(value)
	object{RES_DIS_SIOV_GRND(value,10,2.1,21.5,5.1,25.5,30,1)}
#end
#macro RES_DIS_SIOV_20_75(value)
	object{RES_DIS_SIOV_GRND(value,10,1.6,21.5,4.6,25.5,30,1)}
#end
#macro RES_DIS_SIOV_20_275(value)
	object{RES_DIS_SIOV_GRND(value,10,2.3,21.5,5.4,25.5,30,1)}
#end
#macro RES_DIS_SIOV_20_1000(value)
	object{RES_DIS_SIOV_GRND(value,10,6.9,21.5,11.4,28.5,30,1)}
#end








/********************************************************************************************************************************************
//Uhrenquarz mit 2,5mm Pitch
********************************************************************************************************************************************/
#macro SPC_XTAL_CLOCK_025MM_GRND(value)
	#if(pin_short=off)
		#local spc_pin_length = -5;
	#else
		#local spc_pin_length = -1*(pin_length+pcb_height);
	#end
	union
	{
		superellipsoid{<1,0.12> rotate<90,0,0> scale<1,3,1> translate<0,5,0>}
		sphere_sweep 
		{
			linear_spline 4
			<-0.5,2,0>,0.18
			<-0.5,1.5,0>,0.18
			<-1.27,0.3,0>,0.18
			<-1.27,-5,0>,0.18
		}
		sphere_sweep 
		{
			linear_spline 4
			<0.5,2,0>,0.18
			<0.5,1.5,0>,0.18
			<1.27,0.3,0>,0.18
			<1.27,-5,0>,0.18
		}
		intersection
		{
			superellipsoid{<1,0.12> rotate<90,0,0> scale<1.001,3,1.001> translate<0,5,0> pigment{Black}}
			union{
			text {ttf besch_font value 0.5, 0 pigment{White*0.5} rotate<0,0,90> translate<0.5,2.8,-1.1>}
			text {ttf besch_font value 0.5, 0 pigment{White*0.5} rotate<0,0,90> translate<0.5,2.8,-1.1> rotate<0,180,0>}
		}
	}
	texture{col_silver}}
#end

#macro SPC_XTAL_CLOCK_025MM(value)
	object{SPC_XTAL_CLOCK_025MM_GRND(value)}
#end


/********************************************************************************************************************************************
//Uhrenquarz mit 2,5mm Pitch  - HORIZZONTAL
********************************************************************************************************************************************/
#macro SPC_XTAL_CLOCK_025MM_H_GRND(value)
	#if(pin_short=off)
		#local spc_pin_length = -5;
	#else
		#local spc_pin_length = -1*(pin_length+pcb_height);
	#end
	union
	{
		superellipsoid
		{
			<1,0.12> rotate<90,0,0> scale<1,3,1> translate<0,5,0>
		}
		sphere_sweep 
		{
			linear_spline 4
			<-0.5,2,0>,0.18
			<-0.5,1.5,0>,0.18
			<-1.27,0.3,0>,0.18
			<-1.27,0,5>,0.18
		}
		sphere_sweep 
		{
			linear_spline 4
			<0.5,2,0>,0.18
			<0.5,1.5,0>,0.18
			<1.27,0.3,0>,0.18
			<1.27,0,5>,0.18
		}
		intersection
		{
			superellipsoid{<1,0.12> rotate<90,0,0> scale<1.001,3,1.001> translate<0,5,0> pigment{Black}}
			union
			{
				text {ttf besch_font value 0.5, 0 pigment{White*0.5} rotate<0,0,90> translate<0.5,2.8,-1.1>}
				text {ttf besch_font value 0.5, 0 pigment{White*0.5} rotate<0,0,90> translate<0.5,2.8,-1.1> rotate<0,180,0>
			}
		}
	}
	texture{col_silver}} 
	rotate<90,0,0> 
	translate<0.0,1.2,0.0>
#end

#macro SPC_XTAL_CLOCK_025MM_H(value)
	object{SPC_XTAL_CLOCK_025MM_H_GRND(value)}
#end



//************************************************************************************************************************************
//  GAS_DISCHARGER
//************************************************************************************************************************************

#macro GAS_DISCHARGER_GRND(dis, value)
  	union{
		// -------------------------------------------------- TERMINALS
		//Macro TOOLS_WIRE_LEADS (Length, Width, Wirelength, Wirewidth,  Raster,  BendRadius, Seperation, H_V)
		object{TOOLS_WIRE_LEADS  (2,      2,     4,        0.7,        dis,    1,        4,       "H") translate<0, 4, 0>}

  		// -------------------------------------------------- BLUE BODY
		cylinder {
				<-2.0, 4, 0>,<2.0, 4, 0>, 4
				pigment{color rgb <.25,.25,.65>} 
				finish { phong 0.1 } 	
		}	

		// -------------------------------------------------- TEXT
		intersection{
			cylinder{<0, dis/2, 0><0, -dis/2, 0> 4.01}											//Beschriftung
			text {ttf besch_font "EPCOS" 1.9, 0 scale 1.2 translate<0, 0, -4>}
			rotate<0,20,0>
			translate<4,-0.2,0>
			rotate<0,0,90>
			pigment{rgb <1,1,1>} 
		}
		intersection{
			cylinder{<0,dis/2,0><0,-dis/2,0> 4.01}											//Beschriftung
			text {ttf besch_font value 1.9, 0 scale 1.5 translate<0, 0, -4>}
			rotate<0,-58,0>
			translate<4,-0.2,0>
			rotate<0,0,90>
			pigment{rgb <1,1,1>} 
		}
		intersection{
			cylinder{<0,dis/2,0><0,-dis/2,0> 4.01}											//Beschriftung
			text {ttf besch_font "030" 1.9, 0 scale 1.5 translate<0, 0, -4>}
			rotate<0,-140,0>
			translate<4,-0.2,0>
			rotate<0,0,90>
			pigment{rgb <1,1,1>} 
		}

		// -------------------------------------------------- SILVER CAPS
		difference{
				union{
					
					cylinder {
							<2.0,4.0,0>,<3.0,4.0,0>, 4
							//texture{col_silver}
					} 
					cylinder {
							<-2.0,4.0,0>,<-3.0,4.0,0>, 4
							//texture{col_silver}
					}
				}
				cone {<2.01,4.0,0>,1.4,<3.01,4.0,0>,2.7}
				cone {<-2.01,4.0,0>,1.4,<-3.01,4.0,0>,2.7}
				texture{Chrome_Metal}
		} 
 	}
#end

#macro GAS_DISCHARGER_07(value)
	object{GAS_DISCHARGER_GRND(07.62, value)}
#end
#macro GAS_DISCHARGER_10(value)
	object{GAS_DISCHARGER_GRND(10.16, value)}
#end
#macro GAS_DISCHARGER_12(value)
	object{GAS_DISCHARGER_GRND(12.70, value)}
#end
#macro GAS_DISCHARGER_15(value)
	object{GAS_DISCHARGER_GRND(15.24, value)}
#end
#macro GAS_DISCHARGER_17(value)
	object{GAS_DISCHARGER_GRND(17.78, value)}
#end



//************************************************************************************************************************************
//  INDUCTOR_17
//************************************************************************************************************************************

#macro INDUCTOR_17(value)
  union
  {
	// ----------------------------------------------------- Terminals
	//Macro TOOLS_WIRE_LEADS (Length, Width, Wirelength, Wirewidth,  Raster,  BendRadius, Seperation, H_V)
	object{TOOLS_WIRE_LEADS  (2.0,    2.0,   4.0,        0.7,        18.0,    1.0,        0.0,       "H") translate<0,2.5,0>} 

  	// ----------------------------------------------------- Body
	cylinder {<-6.5,2,0>,<6.5,2,0>,2.5 }
	pigment{color rgb <.2,.1,.15>} 
	finish { phong 0.3 } 	
  }
#end



//************************************************************************************************************************************
//  BUZZER_F_SU
//************************************************************************************************************************************

#macro BUZZER_F_SU(value)

	// Define "LEG" as a local definition.
	#local leg = object
  	{
		union{
			cylinder {<0,-3,0>,<0,6,0>,0.4 texture{col_silver}} 
			difference{
	        		cylinder {<0,2,0>,<0,7,0>,2.9}
	        		box {<-0.5,1.9,0>,<0.5,7.1,8>}		
			}
		}
  	}


  	union{ 
        	union{        
			// ---------------------------------------------------- All legs in place
  			object{ leg rotate<0,40,0> translate<0,0,15>}
  			object{ leg rotate<0,-170,0> translate<-13,0,-7.5>}
			object{ leg rotate<0,-290,0> translate<13,0,-7.5>}

  			// ---------------------------------------------------- Body 
			difference{
				cylinder {<0,5.7,0>,<0,12.7,0>,15}  
				cylinder {<0,8,0>,<0,13,0>,2}
				object{torus {15,1} translate<0,12.7,0>} 
	  		} 
			object{torus {14,1} translate<0,11.6,0>} 
	
			pigment{color rgb <.15,.15,.15>}
			//finish { phong 0.5 }
			finish { specular 0.9 roughness 0.02 }  
  		}
	
  		// ---------------------------------------------------- Logo
 		box {<-5,12.8,-12>,<5,12.8,12> pigment{image_map{png "EastLogo_E.png" once}  rotate<90,0,0> scale<10,0,3> translate<-5,0,9>}}
	}
#end




//************************************************************************************************************************************
//  WEIDMULLER_LSF
//************************************************************************************************************************************

#macro WEIDMULLER_LSF() 

        // Define "LEG" as a local definition.
  	#local leg = object{
	cylinder {<0,-4,-3.8>,<0,1.5,-3.8>,0.3 texture{col_silver}}
	}       
	
	#local button = object{
	box {<-1.5,5,-5.5>,<1.5,7.5,-7.5>  pigment{color rgb <.9,.9,.9>}} 
	}

  union{
	// All legs in place
  	object{ leg translate<-17.78,0,0>}  
  	object{ leg translate<-12.70,0,0>}
  	object{ leg translate<-7.62,0,0>}
  	object{ leg translate<-2.54,0,0>}
  	object{ leg translate<2.54,0,0>} 
  	object{ leg translate<7.62,0,0>}
  	object{ leg translate<12.70,0,0>}
  	object{ leg translate<17.78,0,0>} 
  	
  	object{ leg translate<-17.78,0,7.62>}  
  	object{ leg translate<-12.70,0,7.62>}
  	object{ leg translate<-7.62,0,7.62>}
  	object{ leg translate<-2.54,0,7.62>}
  	object{ leg translate<2.54,0,7.62>} 
  	object{ leg translate<7.62,0,7.62>}
  	object{ leg translate<12.70,0,7.62>}
  	object{ leg translate<17.78,0,7.62>}

	
  	// Body
	box {<-19.9,0,-5.5>,<19.9,7.8,6.0>  pigment{color rgb <.2,.2,.2>}}  
	box {<-19.9,7.8,-5.5>,<19.9,8.8,-3>  pigment{color rgb <.2,.2,.2>}}
	
	object{ button translate<-17.78,0,0>}  
  	object{ button translate<-12.70,0,0>}
  	object{ button translate<-7.62,0,0>}
  	object{ button translate<-2.54,0,0>}
  	object{ button translate<2.54,0,0>} 
  	object{ button translate<7.62,0,0>}
  	object{ button translate<12.70,0,0>}
  	object{ button translate<17.78,0,0>} 	
	}
#end




/********************************************************************************************************************************************
// ARK_254MM - Green 2.54mm screw terminal 
********************************************************************************************************************************************/

#macro ARK_254MM_GRND(j)
// Based on Macro "ARK_PIN", Designed by Friedrich Bleikamp, Lenord, Bauer & Co. Gmbh <fbleikamp@lenord.de>
// Modified by Livio Cicala
#macro ARK_PIN_254MM()
union{

	// --------------------------------------------------------------------- Soldering
	cylinder{<0,-3.0,0><0,0.85,0>0.45 texture{col_silver}}
	cone{<0,-3.0,0>0.45<0,-3.4,0>0.1 texture{col_silver}}

	// --------------------------------------------------------------------- Plastic body
	difference{
		box{<-1.27,0,-3.3><1.27,10.0,3.3>}               				// Main box
		box{<-1.0,1.3,-4><1.0,5.1,2.2>}               					// Hole for wire entry
		box{<-2.6,8,0><2.6,0,-3> rotate<-14,0,0> translate<0,5.2,5.7>}		// Bevel rear upper
		box{<-2.6,8,0><2.6,0,-3> rotate<18,0,0> translate<0,5.2,-3>}		// Bevel front upper
		cylinder{<0,5.2,0><0,11,0>1.0}                  				// Vertical holes for the screw
		pigment{ForestGreen}
	} 
      
	// --------------------------------------------------------------------- Screw
	difference{
		superellipsoid{<1,0.1> rotate<90,0,0> scale<0.9,0.5,0.9> texture{col_silver} translate<0,9.0,0>}
		box{<0.25,0,-2><-0.25,1,2>rotate<0,rand(global_seed)*180,0> translate<0,9.1,0>}
		texture { T_Chrome_5B }
	}

	// --------------------------------------------------------------------- Metallic interior
	difference{
		box{<-0.8,1.5,-2.5><0.8,4.9,2.5>}		// Main body
		cylinder{<0,3.2,-3.0><0,3.2,3>0.7}		// Hole
		texture { T_Chrome_5B }
	}
}
#end

union{
	#local i = 0;
	#while(i<j)
		object{ARK_PIN_254MM() translate<i*2.54,0,0>}
		#local i=i+1;
	#end
	
	union{
		#local i = 0;
		#while(i<j)
			text {ttf besch_font str(j-i,0,0) 0.1,0  scale<1.8,1.8,2> rotate<18,0,0> translate<-i*2.54-1.27,5.9,-2.8> translate<0,0.3,0.1> pigment{Black}}
			#local i=i+1;
		#end
		translate<(i-1)*2.54+0.9,0,0>
	}
	translate<-j*1.27+1.27,0,0>
}
#end

#macro ARK_254MM_1()
object{ARK_254MM_GRND(1)}
#end
#macro ARK_254MM_2()
object{ARK_254MM_GRND(2)}
#end
#macro ARK_254MM_3()
object{ARK_254MM_GRND(3)}
#end
#macro ARK_254MM_4()
object{ARK_254MM_GRND(4)}
#end
#macro ARK_254MM_5()
object{ARK_254MM_GRND(5)}
#end
#macro ARK_254MM_6()
object{ARK_254MM_GRND(6)}
#end
#macro ARK_254MM_7()
object{ARK_254MM_GRND(7)}
#end
#macro ARK_254MM_8()
object{ARK_254MM_GRND(8)}
#end




//************************************************************************************************************************************
//  MICRO_MOLLE
//************************************************************************************************************************************

#macro MICRO_MOLLE()        
	union {                   
                // -------------------------------------------------- piedini                                                                           
                box {<-1.7,0,-0.2>,<-1,-3,0.2>}
                box {<1.7,0,-0.2>,<1,-3,0.2>}                                                                         
                                                                                           
                // -------------------------------------------------- molla
                box {<-1.7,0,-0.2>,<1.7,2.6,0.2>}                                    // gambo iniziale
	          box {<-1.7,3,-0.6>,<1.7,3.4,-12>}                                    // parte lunga 
	          box {<-1.7,-0.2,0>,<1.7,0.2,4> rotate<36,0,0> translate<0,3,-12> }   // parte piegata
                      
                // -------------------------------------------------- prima curva      
                difference{ 
                cylinder {<-1.7,2.6,-0.6>,<1.7,2.6,-0.6>,0.8}
                cylinder {<-1.8,2.6,-0.6>,<1.7,2.6,-0.6>,0.4} 
                box {<-1.8,1.8,-1.4>,<1.8,3.0,-0.6>}
                box {<-1.8,1.8,-1.4>,<1.8,2.6,-0.2>}                          
                }  
                  
                // -------------------------------------------------- seconda curva
                cylinder {<-1.7,3.1,-12>,<1.7,3.1,-12>,0.3} 
                    
                // -------------------------------------------------- posizione e colore 
                translate<0,0,3.86>     
                texture{col_gold}
                finish { phong 0.5 }     
	}    
#end





//************************************************************************************************************************************
//  INDUCTOR_1210
//************************************************************************************************************************************

// a,b,c = length/heigth/width ( body )
// d,e,f = length/heigth/width ( terminals )

#macro INDUCTOR_GRND(value, a, b, c, d, e, f)
	union 
	{ 
		box{<-a/2, 0, -c/2>,<a/2, b, c/2> pigment{Gray20}}			// body
		box{<-a/2 -d, 0, -f/2>,<-a/2, e, f/2> texture{col_silver}}	// terminal 1
		box{<a/2 +d, 0, -f/2>,<a/2, e, f/2> texture{col_silver}}	// terminal 2
		Text2(value, -1.2, a*0.7, b)								// text
	}
#end

#macro INDUCTOR_1210(value)
	object{INDUCTOR_GRND(value, 3.0, 2.0, 2.54, 0.1, 1.4, 1.4)}
#end




//********************************************************************************************************************************************
// INDUCTOR MSD75 - SMD 4.7mH - 7 x 8 x 4 mm
//********************************************************************************************************************************************
#macro INDUCTOR_MSD75_GRND(value)

	// ---------------------------------- SURFACE constructor
	#local SURFACE =
	texture{
	   pigment{White*.3}
	}

	// ---------------------------------- objects
	#local L_PHASE=
	torus{
	   4,0.5
	   texture {SURFACE}
	}

	#local L_KABELNUT=
	cylinder{
	   <0, -4, 0>,
	   <0,4,0>,
	   0.75
	   texture {SURFACE}
	}

	#local L_BOTTOM=
	difference{
	   cylinder {
		   <0, 0, 0>,
		   <0, 2, 0>,
			4
		   texture {SURFACE}
	   }
	   union{
		   object{L_PHASE}
		   object{L_KABELNUT translate -4*x}
		   object{L_KABELNUT translate 4*x}
	   }
	}

	#local L_COVER = object{L_BOTTOM rotate x*180 translate 2*y}

	#local L_CENTER = cylinder {<0, 0, 0>, <0, 6, 0>, 2 texture {SURFACE} }

	#local L_CORE=
	union{
	   object{L_BOTTOM}
	   object{L_CENTER translate y*2}
	   object{L_COVER translate y*8}
	}

	// ***** Kupferlackkabelemente ****************************************
	#local WireThickness = .5;

	#local L_CONJUNCTION=
	cylinder{
		<0,0,0>
		<0,2,0>
		WireThickness/2
		texture{T_Gold_1A }
	}

	#local L_WINDINGS =
	torus {
	   3, WireThickness/2
	   texture {T_Gold_1A }
	}

	#local L_COIL=
	union {
		#local i=0;
		#while(i<11)
		  object{L_WINDINGS translate i*WireThickness*y}
		  #local i=i+1;
		#end
	}

	// *** Zusammenbau der Spule: ***************************************************************
	#local L_COMPONENT =
	union
	{
	   object{L_CORE}
	   object{L_COIL translate (2+WireThickness/2)*y}
	   object{L_CONJUNCTION translate -3.2*x}
	   object{L_CONJUNCTION translate 3.2*x}

	   //text {ttf besch_font value 0.01, 0 pigment{Black}
			 //  scale 1
			 //  rotate 90*x rotate 180*y
			 //  translate <2,10+0.1,-0.5>}
	}
	object{L_COMPONENT scale<0.95,0.4,0.95>}
#end

#macro INDUCTOR_MSD75(value)
	object{INDUCTOR_MSD75_GRND(value)}
#end






//************************************************************************************************************************************
//  DIODE SMD
//************************************************************************************************************************************

// a,b,c = length/heigth/width ( body )
// d,e,f = length/heigth/width ( terminals )

#macro DIODE_SMD_GRND(value, a, b, c, d, e, f)
	union 
	{ 
		box{<-a/2, 0, -c/2>,<a/2, b, c/2> pigment{Gray20}}							// body
		box{<-a/2 -d, 0, -f/2>,<-a/2, e, f/2> texture{col_silver}}					// terminal 1
		box{<a/2 +d, 0, -f/2>,<a/2, e, f/2> texture{col_silver}}					// terminal 2
		box{<-a/2 +0.3, b +0.01, -c/2>,<-a/2 +0.6, b +0.01, c/2> pigment{White}}	// white cathode mark
		Text2(value, -0.55, a*0.7, b)												// text
	}
#end

#macro DIODE_SMD_1006(value)
	object{DIODE_SMD_GRND(value, 2.54, 2.0, 1.524, 0.6, 0.15, 0.6)}
#end



/********************************************************************************************************************************************
// DIODES SOD123 and SOD323
********************************************************************************************************************************************/
#macro DIODE_SMD_SOD_GRND(value, L, B, H, LG, BP, DP)
	union
	{
		difference
		{
			// ---------------------------------------------------------------------------- PLASTIC BODY
			box{<-L/2,0,-B/2><L/2,H,B/2>}
			// ---------------------------------------------------------------------------- WITH SHAPED SIDES
			box{<0,0,-B><H,H,B> rotate<0,0,10> translate<L/2,H/2,0>}
			box{<0,0,-B><-H,H,B> rotate<0,0,-10> translate<-L/2,H/2,0>}
			box{<0,0,-B><H,-H,B> rotate<0,0,-10> translate<L/2,H/2,0>}
			box{<0,0,-B><-H,-H,B> rotate<0,0,10> translate<-L/2,H/2,0>}
			box{<-L,0,0><L,H,H> rotate<-10,0,0> translate<0,H/2,B/2>}
			box{<-L,0,0><L,H,-H> rotate<10,0,0> translate<0,H/2,-B/2>}
			box{<-L,0,0><L,-H,H> rotate<10,0,0> translate<0,H/2,B/2>}
			box{<-L,0,0><L,-H,-H> rotate<-10,0,0> translate<0,H/2,-B/2>}
			pigment{Gray30}
		}
		// -------------------------------------------------------------------------------- WHITE LINE
		box{<-L/2+L/10,H,-B/2+B/10><-L/2+L/10+L/10,H+0.01,B/2-B/10> pigment{Gray80}}

		// -------------------------------------------------------------------------------- TRANSLATE TEXT
		#local s1 = value;
		#if (strcmp(s1, "PMEG2010") = 0) #local s1 = "AH"; #end
		#if (strcmp(s1, "PMEG1020") = 0) #local s1 = "E2"; #end
		#if (strcmp(s1, "MBR0520") = 0) #local s1 = "B2J"; #end
		#if (strcmp(s1, "ZLLS400") = 0) #local s1 = "40"; #end
		#if (strcmp(s1, "S1FLM") = 0) #local s1 = "A1FM"; #end
		#if (strcmp(s1, "RS1KL") = 0) #local s1 = "RKLB6"; #end
		#if (strcmp(s1, "MMSZ4678") = 0) #local s1 = "CCK"; #end
		#if (strcmp(s1, "MMSZ4683") = 0) #local s1 = "CJK"; #end
		#if (strcmp(s1, "MMSZ4687") = 0) #local s1 = "CPU"; #end
		#if (strcmp(s1, "MMSZ4690") = 0) #local s1 = "CUP"; #end
		#if (strcmp(s1, "MMSZ4697") = 0) #local s1 = "DEU"; #end
		#if (strcmp(s1, "MMSZ18") = 0) #local s1 = "X2X"; #end
		#if (strcmp(s1, "MMSZ5270") = 0) #local s1 = "P5U"; #end
		#if (strcmp(s1, "MMSZ5261") = 0) #local s1 = "N1B7"; #end
		#if (strcmp(s1, "MMSZ5259") = 0) #local s1 = "M4B3"; #end

		// -------------------------------------------------------------------------------- PRINT TEXT
		Text(s1, -L/2+L/4, B*0.95, H+0.01)

		// -------------------------------------------------------------------------------- PINS
		box{<-BP/2-0.2,0,-BP/2><BP/2,0.1,BP/2> translate<LG/2-DP,0,0>}
		box{<-BP/2,0,-BP/2><BP/2+0.2,0.1,BP/2> translate<-LG/2+DP,0,0>}
		texture{col_silver}
	}
#end

// Parameter:  Text,	Laenge,    Breite,    Hoehe des Kunststoffkoerpers,  Laenge incl. Pins,           Breite der Anschluesse.
// Parameters: Text,	length,    width,     height of the plastic tube,    length including pins,       Width of the connections.
// Parametri:  Testo,	lunghezza, larghezza, altezza del corpo in plastica, lunghezza compresa piedini,  larghezza delle connessioni.

#macro DIODE_SMD_SOD123(value)
object{DIODE_SMD_SOD_GRND(value, 2.6, 1.7, 1.2, 3.6, 0.6, 0.22)}
#end
#macro DIODE_SMD_SOD323(value)
object{DIODE_SMD_SOD_GRND(value, 1.7, 1.3, 0.8, 2.7, 0.35, 0.22)}
#end





//************************************************************************************************************************************
//  SMD CRYSTAL 4
//************************************************************************************************************************************

#macro SMD_XTAL_GRND(value)

    union{
        superellipsoid { <0.15, 0.15> scale <3.5,  0.455, 2.0> translate <0, 0.6-0.045, 0> texture{T_Brass_5A} }
        superellipsoid { <0.15, 0.15> scale <3.35, 0.55,  1.85> translate <0, 0.6+0.05, 0> texture{T_Brass_5A} }
        superellipsoid { <0.15, 0.15> scale <3.3,  0.61,  1.8> translate <0, 0.6+0.11, 0> pigment{Gray50} }
        
        superellipsoid { <0.05, 0.05> scale <0.05, 0.2, 0.3> translate <-3.5, 0.2+0.05, -1.2> texture{col_silver} }
        superellipsoid { <0.05, 0.05> scale <0.05, 0.2, 0.3> translate <-3.5, 0.2+0.05, +1.2> texture{col_silver} }
        superellipsoid { <0.05, 0.05> scale <0.05, 0.2, 0.3> translate <+3.5, 0.2+0.05, -1.2> texture{col_silver} }
        superellipsoid { <0.05, 0.05> scale <0.05, 0.2, 0.3> translate <+3.5, 0.2+0.05, +1.2> texture{col_silver} }
         
        text {ttf global_fontfile_arial_bold value 0.05, 0 pigment{Gray30} scale <1,0,.8> rotate<90,0,0> translate<-2.0,1.34,-0.35>}     
    }

#end

#macro SMD_XTAL_4(value)
	object{SMD_XTAL_GRND(value)}
#end









/********************************************************************************************************************************************
//Makro fuer Pin von SO und aehnlichem (Kopie von QFP-Pin)
//H = Hoehe des Pins
//B = Breite des Pins
//T = Tiefe des Pins
//S = Materialstaerke des Pins
********************************************************************************************************************************************/
#macro IC_SMD_PIN(H,B,T,S)
	union
	{
		box{<0,H,T/2><B/4,H-S,-T/2>}
		difference{
		cylinder{<B/4,H-S,-T/2><B/4,H-S,T/2>S}
		box{<-1,H-S,-T/2-0.01><B/2,H-S-3,T/2+0.01>}}
		box{<B/4,H-S,-T/2><B/4+S,S,T/2>}
		difference
		{
			cylinder{<B/4+S,S,-T/2><B/4+S,S,T/2>S}
			box{<0,S,-T/2-0.01><B,S+3,T/2+0.01>}
		}
		box{<B/4+S,0,-T/2><B,S,T/2>}
		difference
		{
			box{<B/4+S,S,-T/2><B/4+S+S/2,1.5*S,T/2>}
			cylinder{<B/4+S+S/2,S+S/2,T/2+0.01><B/4+S+S/2,S+S/2,-T/2-0.01>,S/2}
			//box{<0,0,-T/2><B,H,T/2> pigment{White filter 0.9}
		}
		texture{col_silver}
	}
#end


/********************************************************************************************************************************************
//Makro fuer SMD-IC's die Pins nur auf 2-Seiten haben(SO, TSOP, TSSOP usw.)
//ueberarbeitet von Tilmann Reh <tilmann.reh(replace with at)autometer.de>
//erweitert fuer DPAK Friedrich Bleikamp <fbleikamp(replace with at)web.de>
//LK      = Laenge des Kunststoff(Seite der Pins)
//BK      = Breite des Kunststoff(Seite ohne Pins)
//HK      = Hoehe des Kunststoff
//B       = Laenge der Seite ohne Pins ueber alles
//pin_u   = Pins auf der "unteren" Seite
//pin_o   = Pins auf der "oberen" Seite
//ptch_u  = Pitch der Pins auf der "unteren" Seite
//ptch_o  = Pitch der Pins auf der "oberen" Seite
//pinb_u  = Breite der Pins auf der "unteren" Seite
//pinb_o  = Breite der Pins auf der  "oberen" Seite
//pin_s   = Staerke des Pinmaterials
//di_pcb  = Abstand des Kunststoff zur Platine
//kor_w   = Korrekturwinkel
//pin0_m  = Pin-1-Markierung: 0 = keine, 1 = Farbklecks, 2 = Kerbe wie bei DIP, 3 = PowerSO, 4 = DPAK
//pin0_45 = Wenn != 0 wird an der unteren Seite ein Winkel am Koerper von 45 statt 10 verwendet (SO)
//pin0_a  = Abstand des Pin0-Kennzeichners vom Rand
//besch_s = Scalefaktor der Beschriftung
//besch_w = Wenn != 0 wird Beschriftung gedreht
//logo  = Name of the logo
********************************************************************************************************************************************/
#macro IC_SMD_GRND(LK,BK,HK,B,pin_u,pin_o,ptch_u,ptch_o,pinb_u,pinb_o,pin_s,di_pcb,kor_w,pin0_m,pin0_45,pin0_a,besch_s,besch_w,logo)
union{
	difference{
		box{<LK/2,di_pcb,BK/2><-LK/2,di_pcb+HK,-BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,-HK,1>  rotate<10,0,0> translate<0,(di_pcb+HK)/2-pin_s/2,BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,-HK,-1>  rotate<-10,0,0> translate<0,(di_pcb+HK)/2-pin_s/2,-BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,HK,1>  rotate<-10,0,0> translate<0,(di_pcb+HK)/2+pin_s/2,BK/2>}
		box{<LK/2+0.01,0,0><-LK/2-0.1,HK,-1>  rotate<10,0,0> translate<0,(di_pcb+HK)/2+pin_s/2,-BK/2>}
		#if(pin0_45!=0)
			box{<LK/2+0.01,0,0><-LK/2-0.1,HK,-1>  rotate<45,0,0> translate<0,(di_pcb+HK)/2+pin_s/2+pin_s*1.5,-BK/2>}
		#end
		box{<0,0,-BK/2-0.1><1,HK,BK/2+0.1>  rotate<0,0,10> translate<LK/2,(di_pcb+HK)/2+pin_s/2,0>}
		box{<0,0,-BK/2-0.1><-1,HK,BK/2+0.1>  rotate<0,0,-10> translate<-LK/2,(di_pcb+HK)/2+pin_s/2,0>}
		box{<0,0,-BK/2-0.1><1,-HK,BK/2+0.1>  rotate<0,0,-10> translate<LK/2,(di_pcb+HK)/2-pin_s/2,0>}
		box{<0,0,-BK/2-0.1><-1,-HK,BK/2+0.1>  rotate<0,0,10> translate<-LK/2,(di_pcb+HK)/2-pin_s/2,0>}
		#if(pin0_m = 0) 
			#local TextX = -LK/2+0.1*LK; 
		#end // ohne Pin-1-Markierung
		#if(pin0_m = 1)  // SO-Farbmarkierung
			#local TextX = -LK/2+0.1*LK;
			#if((((pin_u-1)/2*ptch_u)+0.3)>LK/2) 
				#local i = -(pin_u-1)/2*ptch_u+0.3;
			#else 
				#local i = -(pin_u-1)/2*ptch_u; 
			#end
			sphere{<i,HK+di_pcb+0.1,-BK/2+pin0_a>0.15 pigment{White}}
		#end
		#if(pin0_m = 2)  // VSO-Kerbe
			#local TextX = -LK/2+0.15*LK;
			cylinder{<-LK/2,di_pcb+0.7*HK,0><-LK/2,di_pcb+HK+0.1,0> 1}
		#end
		#if(pin0_m = 3)  // PSO-Kerben und Fase (vereinfacht rechteckig)
			#local TextX = -LK/2+0.25*LK;
			box{<3,di_pcb-0.1,-3> <-3,HK+di_pcb+0.1,0> rotate<0,45,0> translate<1-LK/2,0,1-BK/2>}
			box{<0,di_pcb-0.1,-1.45> <-2,HK+di_pcb+0.1,1.45> translate<1.45-LK/2,0,0>}
			box{<0,di_pcb-0.1,-1.45> <2,HK+di_pcb+0.1,1.45> translate<-1.45+LK/2,0,0>}
		#end
		
		#if(pin0_m = 4) // fuer DPAK ohne Pin-1-Markierung
			#local TextX = -LK/2+0.15*LK; 
		#end 
	}
	#if(pin0_m = 3)  // PSO-Metallboden (vereinfacht, da der Rest sowieso unsichtbar bleibt)
		box{<-LK/2,0,-1.5> <LK/2,1,1.5> texture{col_silver}}
	#end

	#if(pin0_m = 4)  // DPAK-SEATING PLANE & BLIND PIN
	        box{<-pinb_u/2,(HK+di_pcb)/2+pin_s/2,-(BK/2+1)> <pinb_u/2,(HK+di_pcb)/2-pin_s/2,-(BK/2-0.1)> texture{col_silver}}
	        box{<-0.57,0,-5.25> <0.57,0.5,-4.5> translate<ptch_u/2,0,0> texture{col_silver}} 
	        box{<-0.57,0,-5.25> <0.57,0.5,-4.5> translate<-ptch_u/2,0,0> texture{col_silver}} 
	        difference{
		        box{<-2.5,0,-0.85> <2.5,0.55,4.5>} 
		        box{<-0.5,-0.1,-0.5> <0.5,1.1,0.5> rotate <0,45,0> translate<-2.5,0,4.5>}
		        box{<-0.5,-0.1,-0.5> <0.5,0.6,0.5> rotate <0,45,0> translate<2.5,0,4.5>}
		        texture{col_silver}
		        }
	#end
		
	#local i=0;
	#while(i<(pin_u/2))
		#if((pin_u/2)=div(pin_u,2))
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<ptch_u*i+ptch_u/2,0,-BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<-ptch_u*i-ptch_u/2,0,-BK/2>}
		#else
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<ptch_u*i,0,-BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_u,pin_s) rotate<0,90,0> translate<-ptch_u*i,0,-BK/2>}
		#end
		#local i=i+1;
	#end
	
	#local i=0;
	#while(i<(pin_o/2))
		#if((pin_o/2)=div(pin_o,2))
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<ptch_o*i+ptch_o/2,0,BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<-ptch_o*i-ptch_o/2,0,BK/2>}
		#else
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<ptch_o*i,0,BK/2>}
			object{IC_SMD_PIN((HK+di_pcb)/2+pin_s/2,(B-BK)/2,pinb_o,pin_s) rotate<0,-90,0> translate<-ptch_o*i,0,BK/2>}
		#end
	#local i=i+1;
	#end
		

	// -------------------------------------------------------------------------------- TRANSLATE TEXT
	#local s1 = value;
	#if (strcmp(s1, "BF862") = 0) #local s1 = "2AW"; #end
	#if (strcmp(s1, "BF861A") = 0) #local s1 = "28W"; #end
	#if (strcmp(s1, "BC846") = 0) #local s1 = "10W"; #end
	#if (strcmp(s1, "BC857") = 0) #local s1 = "3H"; #end
	#if (strcmp(s1, "2222") = 0) #local s1 = "1P"; #end
	#if (strcmp(s1, "2907") = 0) #local s1 = "2F"; #end
	#if (strcmp(s1, "MMBTA42") = 0) #local s1 = "1T"; #end
	#if (strcmp(s1, "741G66") = 0) #local s1 = "C665"; #end  // or "C66R"
	#if (strcmp(s1, "MCP1700-3v3") = 0) #local s1 = "CS6D"; #end
	#if (strcmp(s1, "MCP1700-3.3V") = 0) #local s1 = "CS6D"; #end
	
	// ---------------------------------------------- text
	Text2(s1, -LK*0.3, LK*0.6, HK+di_pcb)

	// ---------------------------------------------- final rotation and global color
	rotate<0,kor_w,0>
	pigment{Gray20}

}
#end

#macro DIL_SMD_8(value,logo)
object{IC_SMD_GRND(9.5,6.5,1.35,10,4,4,2.54,2.54,0.4,0.4,0.22,0.18,0,1,1,3.9/5,3.9/5,0,logo)}
#end

#macro IC_SMD_SO8(value,logo)
object{IC_SMD_GRND(4.9,3.9,1.35,6,4,4,1.27,1.27,0.4,0.4,0.22,0.18,0,1,1,3.9/5,3.9/5,0,logo)}
#end
#macro IC_SMD_SO14(value,logo)
object{IC_SMD_GRND(8.65,3.9,1.35,6,7,7,1.27,1.27,0.4,0.4,0.22,0.18,0,1,1,3.9/5,3.9/4,0,logo)}
#end
#macro IC_SMD_SO16(value,logo)
object{IC_SMD_GRND(9.9,3.9,1.35,6,8,8,1.27,1.27,0.4,0.4,0.22,0.18,0,1,1,3.9/5,3.9/4,0,logo)}
#end
#macro IC_SMD_SO16W(value,logo)
object{IC_SMD_GRND(10.3,7.5,2.35,10.3,8,8,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_UMAX10(value,logo)
object{IC_SMD_GRND(3,3,0.8,4.9,5,5,0.5,0.5,0.22,0.22,0.13,0.1,0,1,0,0.4,0.7,0,logo)}
#end
#macro IC_SMD_UMAX8(value,logo)
object{IC_SMD_GRND(3,3,0.8,4.9,4,4,0.65,0.65,0.3,0.3,0.13,0.1,0,1,0,0.4,0.7,0,logo)}
#end
//Rudi Hofer <rudi.hofer@t-online.de>
#macro IC_SMD_SO18W(value,logo)
object{IC_SMD_GRND(11.6,7.5,2.35,10.3,9,9,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_SO20W(value,logo)
object{IC_SMD_GRND(12.8,7.5,2.35,10.3,10,10,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_SO24W(value,logo)
object{IC_SMD_GRND(15.4,7.5,2.35,10.3,12,12,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_SO28W(value,logo)
object{IC_SMD_GRND(17.9,7.5,2.35,10.3,14,14,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_SO32_400(value,logo)
object{IC_SMD_GRND(20.5,7.5,2.35,10.3,16,16,1.27,1.27,0.4,0.4,0.27,0.2,0,1,1,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_SO32_525(value,logo)
object{IC_SMD_GRND(20.5,11.43,2.74,14.12,16,16,1.27,1.27,0.4,0.4,0.2,0.05,0,1,1,7.5/5,7.5/5,0,logo)}
#end
#macro IC_SMD_TSSOP8(value,logo)
object{IC_SMD_GRND(2.9,4.4,1,6.4,4,4,0.65,0.65,0.22,0.22,0.15,0.1,0,1,0,0.5,0.6,1,logo)}
#end
#macro IC_SMD_TSSOP14(value,logo)
object{IC_SMD_GRND(5,4.4,1.1,6.375,7,7,0.65,0.65,0.22,0.22,0.15,0.1,0,1,0,0.5,0.8,0,logo)}
#end
#macro IC_SMD_TSSOP16(value,logo)
object{IC_SMD_GRND(5.2,4.4,1.1,6.375,8,8,0.65,0.65,0.22,0.22,0.15,0.1,0,1,0,0.5,0.8,0,logo)}
#end
#macro IC_SMD_TSSOP20(value,logo)
object{IC_SMD_GRND(6.5,4.4,1.1,6.375,10,10,0.65,0.65,0.22,0.22,0.15,0.1,0,1,0,0.5,1.0,0,logo)}
#end
#macro IC_SMD_TSSOP24(value,logo)
object{IC_SMD_GRND(7.8,4.4,1.1,6.375,12,12,0.65,0.65,0.22,0.22,0.15,0.1,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_TSSOP28(value,logo)
object{IC_SMD_GRND(9.7,4.4,1.1,6.375,14,14,0.65,0.65,0.22,0.22,0.15,0.1,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_TSSOP38(value,logo)
object{IC_SMD_GRND(9.7,4.4,1.1,6.4,19,19,0.5,0.5,0.22,0.22,0.15,0.1,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_TSSOP48(value,logo)
object{IC_SMD_GRND(12.5,6.1,0.95,8.1,24,24,0.5,0.5,0.22,0.22,0.15,0.1,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_TSSOP56(value,logo)
object{IC_SMD_GRND(14,6.1,0.95,8.1,28,28,0.5,0.5,0.22,0.22,0.15,0.1,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_TSSOP64(value,logo)
object{IC_SMD_GRND(17,6.1,0.95,8.1,32,32,0.5,0.5,0.22,0.22,0.15,0.1,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_QSOP16(value,logo)
object{IC_SMD_GRND(4.9,3.9,1.45,6,8,8,0.635,0.635,0.25,0.25,0.225,0.15,0,1,1,0.7,0.7,0,logo)}
#end
#macro IC_SMD_QSOP20(value,logo)
object{IC_SMD_GRND(8.65,3.9,1.45,6,10,10,0.635,0.635,0.25,0.25,0.225,0.15,0,1,1,0.7,1.1,0,logo)}
#end
#macro IC_SMD_QSOP24(value,logo)
object{IC_SMD_GRND(8.65,3.9,1.45,6,12,12,0.635,0.635,0.25,0.25,0.225,0.15,0,1,1,0.7,1.1,0,logo)}
#end
#macro IC_SMD_QSOP28(value,logo)
object{IC_SMD_GRND(9.9,3.9,1.45,6,14,14,0.635,0.635,0.25,0.25,0.225,0.15,0,1,1,0.7,1.1,0,logo)}
#end
#macro IC_SMD_SSOP14(value,logo)
object{IC_SMD_GRND(6.2,5.3,1.7,7.7,7,7,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.85,0,logo)}
#end
#macro IC_SMD_SSOP16(value,logo)
object{IC_SMD_GRND(6.2,5.3,1.7,7.7,8,8,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.85,0,logo)}
#end
#macro IC_SMD_SSOP20(value,logo)
object{IC_SMD_GRND(7.2,5.3,1.7,7.7,10,10,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.95,0,logo)}
#end
#macro IC_SMD_SSOP24(value,logo)
object{IC_SMD_GRND(8.2,5.3,1.7,7.7,12,12,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.95,0,logo)}
#end
#macro IC_SMD_SSOP28(value,logo)
object{IC_SMD_GRND(10.2,5.3,1.7,7.7,14,14,0.65,0.65,0.32,0.32,0.15,0.15,0,1,0,0.5,0.95,0,logo)}
#end
#macro IC_SMD_SSOP30(value,logo)
object{IC_SMD_GRND(10.2,6.1,1.2,8.1,15,15,0.65,0.65,0.24,0.24,0.15,0.1,0,1,0,0.5,0.95,0,logo)}
#end
#macro IC_SMD_SSOP48(value,logo)
object{IC_SMD_GRND(15.8,7.5,2.25,10.2,24,24,0.635,0.635,0.25,0.25,0.15,0.3,0,1,0,0.5,1.1,0,logo)}
#end
//Joseph Zeglinski
#macro IC_SMD_SSOP56DL(value,logo)
object{IC_SMD_GRND(18.4,7.5,2.25,10.2,28,28,0.635,0.635,0.25,0.25,0.15,0.3,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_SSOP56(value,logo)
object{IC_SMD_GRND(23.7,13.3,2.25,10.2,28,28,0.635,0.635,0.25,0.25,0.15,0.3,0,1,0,0.5,1.1,0,logo)}
#end
#macro IC_SMD_TSOPII28(value,logo)
object{IC_SMD_GRND(18.4,10.1,1,11.7,14,14,1.27,1.27,0.4,0.4,0.15,0.1,0,1,0,0.5,1.5,0,logo)}
#end
#macro IC_SMD_TSOPII32(value,logo)
object{IC_SMD_GRND(20.95,10.1,1,11.7,16,16,1.27,1.27,0.4,0.4,0.15,0.1,0,1,0,0.5,1.5,0,logo)}
#end
#macro IC_SMD_TSOPII44(value,logo)
object{IC_SMD_GRND(18.3,10.1,1,11.7,22,22,0.8,0.8,0.375,0.375,0.15,0.1,0,1,0,0.5,1.5,0,logo)}
#end
#macro IC_SMD_TSOPII50(value,logo)
object{IC_SMD_GRND(20.95,10.1,1,11.7,25,25,0.8,0.8,0.375,0.375,0.15,0.1,0,1,0,0.5,1.5,0,logo)}
#end
#macro IC_SMD_TSOPII54(value,logo)
object{IC_SMD_GRND(22.22,10.1,1,11.7,27,27,0.8,0.8,0.375,0.375,0.15,0.1,0,1,0,0.5,1.5,0,logo)}
#end
#macro IC_SMD_TSOPII86(value,logo)
object{IC_SMD_GRND(22.22,10.1,1,11.7,43,43,0.5,0.5,0.22,0.22,0.15,0.1,0,1,0,0.5,1.5,0,logo)}
#end
#macro IC_SMD_TSOP28_13MM(value,logo)
object{IC_SMD_GRND(8,11.8,1,13.4,14,14,0.55,0.55,0.22,0.22,0.13,0.1,90,1,0,0.5,1.1,1,logo)}
#end
#macro IC_SMD_TSOP32_13MM(value,logo)
object{IC_SMD_GRND(8,11.8,1,13.4,16,16,0.5,0.5,0.22,0.22,0.13,0.1,90,1,0,0.5,1.1,1,logo)}
#end
#macro IC_SMD_TSOP32(value,logo)
object{IC_SMD_GRND(8,18.4,1.1,20,16,16,0.5,0.5,0.22,0.22,0.13,0.1,90,1,0,0.5,1.1,1,logo)}
#end
#macro IC_SMD_TSOP48(value,logo)
object{IC_SMD_GRND(12,18.4,1.1,20,24,24,0.5,0.5,0.22,0.22,0.13,0.1,90,1,0,0.5,1.1,1,logo)}
#end
#macro IC_SMD_TSOP56(value,logo)
object{IC_SMD_GRND(14,18.4,1.1,20,28,28,0.5,0.5,0.22,0.22,0.13,0.1,90,1,0,0.5,1.1,1,logo)}
#end
//Tilmann Reh <tilmann.reh@autometer.de>
#macro IC_SMD_VSO40(value,logo)
object{IC_SMD_GRND(15.4,7.55,2.35,12.05,20,20,0.762,0.762,0.36,0.36,0.18,0.2,0,2,0,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_VSO56(value,logo)
object{IC_SMD_GRND(21.7,11.05,2.9,15.5,28,28,0.75,0.75,0.36,0.36,0.18,0.2,0,2,0,11/6,11/5,0,logo)}
#end
#macro IC_SMD_PSO20(value,logo)
object{IC_SMD_GRND(15.9,11,3.3,14.2,10,10,1.27,1.27,0.47,0.47,0.28,0.2,0,3,0,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_PSO36(value,logo)
object{IC_SMD_GRND(15.9,11,3.3,14.2,18,18,0.65,0.65,0.3,0.3,0.28,0.2,0,3,0,7.5/6,7.5/5,0,logo)}
#end
#macro IC_SMD_MSOP10(value,logo)
object{IC_SMD_GRND(3,3,0.85,4.9,5,5,0.5,0.5,0.25,0.25,0.15,0.1,0,1,0,0.5,0.65,0,logo)}
#end
#macro IC_SMD_SOT23(value,logo)
object{IC_SMD_GRND(2.9,1.3,1,2.8,2,1,1.9,1.9,0.45,0.45,0.13,0.1,0,0,0,1.5,0.7,0,logo)}
#end
#macro IC_SMD_SOT23_5(value,logo)
object{IC_SMD_GRND(2.9,1.6,1,2.8,3,2,0.95,1.90,0.35,0.35,0.13,0.1,0,0,0,1.5,0.7,0,logo)}
#end
#macro IC_SMD_SOT23_6(value,logo)
object{IC_SMD_GRND(2.9,1.6,1,2.8,3,3,0.95,0.95,0.35,0.35,0.13,0.1,0,1,0,0.3,0.7,0,logo)}
#end
#macro IC_SMD_SOT223(value,logo)
object{IC_SMD_GRND(6.5,3.5,1.6,7,3,1,2.3,2.3,0.75,3,0.2,0.2,0,0,0,0,1.0,0,logo)}
#end
#macro IC_SMD_SOT363(value,logo)
object{IC_SMD_GRND(2.0,1.25,1.0,2.1,3,3,0.65,0.65,0.25,0.25,0.15,0.1,0,1,0,0,0.5,0,logo)}
#end
//SMD-Transistoren aus SIC_GRND abgeleitet
#macro TR_SOT23(value,logo)
object{IC_SMD_GRND(2.9,1.3,1,2.8,2,1,1.9,1.9,0.45,0.45,0.13,0.1,0,0,0,1.5,0.7,0,logo)}
#end
#macro TR_TO252(value,logo)
object{IC_SMD_GRND(6.1,6.5,2.2,10,2,1,4.5,1.9,0.9,5.3,0.5,0.1,0,0,0,1.5,1.0,0,logo)}
#end
#macro TR_TO263(value,logo)
object{IC_SMD_GRND(10.2,8.7,4.2,15.2,2,1,5.1,1.9,1.4,10.2,0.5,0.1,0,0,0,1.5,1.0,0,logo)}
#end
// Friedrich Bleikamp
#macro IC_SMD_DPAK_369C(value,logo)
object{IC_SMD_GRND(6.1,6.5,2.2,11,2,0,4.5,0,0.8,0,0.5,0.1,0,4,0,1.5,1.0,0,logo)}
#end
#macro IC_SMD_TSOP86(value,logo)
object{IC_SMD_GRND(22.22,10.16,1.2,11.76,43,43,0.5,0.5,0.2,0.2,0.12,0.1,0,2,0,3.9/5,3.9/5,0,logo)}
#end




//************************************************************************************************************************************
//  WIRE SMD
//************************************************************************************************************************************

#macro WIRE_SMD (Wirewidth, Raster, Separation)
union 
{ 
	#local l = Raster * 0.127;
	// ---------------------------------------------------------------------------------- Soldering
	cone{<-l, 0, 0> 0.5 <-l, 0.32, 0> 0 texture{col_silver}}
	cone{<l, 0, 0> 0.5 <l, 0.32, 0> 0 texture{col_silver}}

	// ---------------------------------------------------------------------------------- Horizontal WIRE end-to-end, between elbows 
	cylinder{<-l -0.3, Separation, 0> <l +0.3, Separation, 0> Wirewidth/2 texture{col_silver}}

	// ---------------------------------------------------------------------------------- Body
	cylinder {<-l +0.4, Separation, 0> , <l -0.4, Separation, 0>, Wirewidth*.8}
	pigment {color rgb <0.4, 0.6, 0.2, 0.7>} 
	finish {phong 0.2} 
}
#end

#macro WIRE_SMD_GRND(value)
	// Macro WIRE_SMD ( Wirewidth,	Raster (mils),	Separation)
	object{  WIRE_SMD ( 0.3,		value,			0.1       )}	
#end

#macro WIRE_SMD_20()
	object{WIRE_SMD_GRND(20)}
#end
#macro WIRE_SMD_25()
	object{WIRE_SMD_GRND(25)}
#end
#macro WIRE_SMD_30()
	object{WIRE_SMD_GRND(30)}
#end
#macro WIRE_SMD_35()
	object{WIRE_SMD_GRND(35)}
#end
#macro WIRE_SMD_40()
	object{WIRE_SMD_GRND(40)}
#end
#macro WIRE_SMD_45()
	object{WIRE_SMD_GRND(45)}
#end
#macro WIRE_SMD_50()
	object{WIRE_SMD_GRND(50)}
#end
#macro WIRE_SMD_55()
	object{WIRE_SMD_GRND(55)}
#end
#macro WIRE_SMD_60()
	object{WIRE_SMD_GRND(60)}
#end
#macro WIRE_SMD_65()
	object{WIRE_SMD_GRND(65)}
#end
#macro WIRE_SMD_70()
	object{WIRE_SMD_GRND(70)}
#end
#macro WIRE_SMD_75()
	object{WIRE_SMD_GRND(75)}
#end
#macro WIRE_SMD_80()
	object{WIRE_SMD_GRND(80)}
#end
#macro WIRE_SMD_85()
	object{WIRE_SMD_GRND(85)}
#end
#macro WIRE_SMD_90()
	object{WIRE_SMD_GRND(90)}
#end
#macro WIRE_SMD_95()
	object{WIRE_SMD_GRND(95)}
#end







//********************************************************************************************************************************************
//Macro for  USB-Mini-B
//********************************************************************************************************************************************
#macro CON_USB_B_MINI_GRND()
union
{
	union
	{      
		// ----------------------------------------- metal body                   
		difference
		{      
			union
			{      
				                      // angle, radius, spessore, larghezza, len1, len2

				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,4,0)translate<-3.355,0.15,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,4,0)rotate<0,180,0>translate<3.355,0.15,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,0,1)translate<-3.85,2.15,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,0,1)rotate<0,180,0>translate<3.85,2.15,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,0,1.3)rotate<0,0,180>translate<-3.35,2.2,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,0,1.3)rotate<0,180,180>translate<3.35,2.2,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,4,0)rotate<0,0,180>translate<3.85,3.85,-4.5>}
				union{TOOLS_RECT_BOGEN(0.25,90,0.25,9,4,0)rotate<0,180,180>translate<-3.85,3.85,-4.5>}
			}     
			box { <-4.5, -0.1, -2.9>, <4.5,2.75,-9> }       
			difference
			{                                                                           
				cone {<-2.5,4,-4.5> , 0.75 , <-2.5,4,-1> , 0.5}
				cone {<-2.5,4,-4.5> , 0.5 , <-2.5,4,-2> , 0.25}
			}
			difference
			{                                                                          
				cone {<2.5,4,-4.5> , 0.75 , <2.5,4,-1> , 0.5}
				cone {<2.5,4,-4.5> , 0.5 , <2.5,4,-2> , 0.25}
			}
			difference
			{                                                                           
				box { <-0.75, 3, -1>, <0.75,5,-6> }      
				box { <-0.5, 3, -1>, <0.5,5,-5> }      
			}
		}

		// ----------------------------------------- sides left and right
		box { <-3.85, 0, -9>, <-3.45, 3.5, -3> }     
		box { < 3.85, 0, -9>, < 3.45, 3.5, -3> }      
	
		// ----------------------------------------- ground pins left and right
		box { <-3.85, 0, -3>, <-3.45, -2.4, -4.5> }     
		box { < 3.85, 0, -3>, < 3.45, -2.4, -4.5> }  

		texture{col_silver}
	}


	// -------------------------------------------- black plastic front
	difference
	{
		box { <-2.5,1,-1>,<2.5,2,-7>} 
		box { <-0.25,1.25,0>,<0.25,1.75,-8>} 
		box { <-1.00,1.25,0>,<-0.50,1.75,-8>} 
		box { <-1.75,1.25,0>,<-1.25,1.75,-8>} 
		box { <1.00,1.25,0>,<0.50,1.75,-8>} 
		box { <1.75,1.25,0>,<1.25,1.75,-8>} 
		texture{pigment{color rgb <0.1, 0.1, 0.1>}}
	}

	// -------------------------------------------- black plastic rear
	difference
	{
		box { <-3.75,0,-6>,<3.75,3.75,-8.5>} 
		box { <-2,1.9,-7>,<3,4,-8.6>} 
		box { <-4,3,-8>,<4,4,-8.6>} 
		box { <-3,-0.1,-7.5>,<3,4,-8.6>} 
		box { <-0.25,-0.1,0>,<0.25,2,-8.6>} 
		box { <-1.00,-0.1,0>,<-0.50,2,-8.6>} 
		box { <-1.75,-0.1,0>,<-1.25,2,-8.6>} 
		box { <1.00,-0.1,0>,<0.50,2,-8.6>} 
		box { <1.75,-0.1,0>,<1.25,2,-8.6>} 
		texture{pigment{color rgb <0.1, 0.1, 0.1>}}
	}       

	// ------------------------------------------- contacts
	union
	{
		box { <-0.2, 1.55, -2>,< 0.2, 1.75, -9>} 
		box { <-1.0, 1.55, -2>,<-0.6, 1.75, -7.7>} 
		box { <-1.4, 1.55, -2>,<-1.8, 1.75, -9>} 
		box { < 1.0, 1.55, -2>,< 0.6, 1.75, -7.7>} 
		box { < 1.4, 1.55, -2>,< 1.8, 1.75, -9>} 

		box { <-0.2, 1.75, -8.8>,< 0.2, -2.4, -9>} 
		box { <-1.0, 1.75, -7.5>,<-0.6, -2.4, -7.7>} 
		box { <-1.4, 1.75, -8.8>,<-1.8, -2.4, -9>} 
		box { < 1.0, 1.75, -7.5>,< 0.6, -2.4, -7.7>} 
		box { < 1.4, 1.75, -8.8>,< 1.8, -2.4, -9>}

	  	texture{col_gold}
	}   

	rotate <0,-90,0> 
	translate <-5.842,0,0>
}
#end

#macro CON_USB_B_MINI()
	object{CON_USB_B_MINI_GRND()}
#end